# Generated by Django 4.2.3 on 2024-03-05 12:41

import django.db.models.deletion
import modelcluster.fields
from django.db import migrations, models


def delete_existing_forecasts(apps, schema_editor):
    model = apps.get_model('forecastmanager', 'forecast')
    model.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ('forecastmanager', '0012_alter_forecastperiod_forecast_effective_time'),
    ]

    operations = [
        migrations.RunPython(
            delete_existing_forecasts,
            migrations.RunPython.noop
        ),
        migrations.AlterModelOptions(
            name='city',
            options={'ordering': ['name'], 'verbose_name': 'City', 'verbose_name_plural': 'Cities'},
        ),
        migrations.AlterUniqueTogether(
            name='forecast',
            unique_together={('forecast_date', 'effective_period')},
        ),
        migrations.CreateModel(
            name='WeatherCondition',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sort_order', models.IntegerField(blank=True, editable=False, null=True)),
                ('symbol', models.CharField(max_length=100, verbose_name='Weather Symbol')),
                ('label', models.CharField(max_length=100, unique=True, verbose_name='Label')),
                ('alias', models.CharField(blank=True, max_length=100, null=True, unique=True, verbose_name='Alias')),
                ('parent', modelcluster.fields.ParentalKey(on_delete=django.db.models.deletion.CASCADE,
                                                           related_name='weather_conditions',
                                                           to='forecastmanager.forecastsetting')),
            ],
            options={
                'ordering': ['sort_order'],
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='CityForecast',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sort_order', models.IntegerField(blank=True, editable=False, null=True)),
                ('city', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='forecastmanager.city',
                                           verbose_name='City')),
                ('condition', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE,
                                                to='forecastmanager.weathercondition')),
                ('parent', modelcluster.fields.ParentalKey(on_delete=django.db.models.deletion.CASCADE,
                                                           related_name='city_forecasts',
                                                           to='forecastmanager.forecast')),
            ],
            options={
                'unique_together': {('parent', 'city')},
            },
        ),
        migrations.RemoveField(
            model_name='forecast',
            name='city',
        ),
        migrations.RemoveField(
            model_name='forecast',
            name='condition',
        ),
        migrations.RemoveField(
            model_name='forecast',
            name='data_value',
        ),
        migrations.CreateModel(
            name='DataValue',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sort_order', models.IntegerField(blank=True, editable=False, null=True)),
                ('value', models.CharField(blank=True, max_length=255, null=True, verbose_name='Value')),
                ('parameter', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='data_values',
                                                to='forecastmanager.forecastdataparameters')),
                ('parent', modelcluster.fields.ParentalKey(on_delete=django.db.models.deletion.CASCADE,
                                                           related_name='data_values',
                                                           to='forecastmanager.cityforecast')),
            ],
            options={
                'unique_together': {('parent', 'parameter')},
            },
        ),
    ]
